from collections import deque, defaultdict

def bfs(graph, s, md):
    d = {s: 0}
    queue = deque([s])
    while queue:
        node = queue.popleft()
        if d[node] < md:
            for neighbor in graph[node]:
                if neighbor not in d:
                    d[neighbor] = d[node] + 1
                    queue.append(neighbor)
    
    return {node for node, dist in d.items() if dist <= md}

n, m, k = map(int, input().split())
ms = []
ks = []

for i in range(m):
    ms.append(list(map(int, input().split())))
for i in range(k):
    ks.append(list(map(int, input().split())))

graph = defaultdict(list)
for a, b in ms:
    graph[a].append(b)
    graph[b].append(a)
    
k = set()
for s, md in ks:
    k.update(bfs(graph, s, md))
    
    # Вывод результата
print(len(k))
if k:
    print(*sorted(k))